//
// nicole.cpp
//

#include <iostream>
#include <string>
#include <vector>
using namespace std;

#include "nicole.h"
#include "vocabulary.h"
#include "parser.h"
#include "matrix.h"
#include "log.h"
#include "responder.h"

int main (  )
{

	string output = "";

	string a;
	string b;
	string c;
	string d;
	string e;

	Parser parser;
	Matrix matrix;
	Responder response;

	Log history ( "/tmp/history.txt" );

	// Initialse the randum number seed thingy.
	srand ( ( unsigned int ) time ( 0 ) );

	//
	// Display the heading
	//
	heading (  );

	//
	// Calculate NICOLE Output based on matrix and vocabulary
	// *first time through*

	if ( ( rand (  ) % 2 + 1 ) == 1 )
	{
		//
		// There is a 50% chance that NICOLE will start the conversation first
		//
		matrix.get_phrase ( &a, &b, &c, &d, &e );
		output = response.get ( a, b, c, d, e );

		if ( output != "" )
		{
			// If we don't get any answer, lets skip this for now
			matrix.reply_sentence ( output );

			//
			// Output NICOLE responce
			//
			cout << "NICOLE: >" << output << endl;
			history.record ( output );
		}
		else
		{
			matrix.reset (  );
		}

	}

	while ( !parser.cmd_quit (  ) )
	{

		//
		// Get Human Input
		//
		cout << "Human: >";

		parser.reset (  );
		parser.input (  );

		//
		// If a system command has been entered then process the command
		//

		if ( !parser.empty (  ) )
		{
			if ( parser.is_command (  ) )
			{
				// process system commands here       
				process_cmd ( &parser, &matrix );

			}
			else
			{
				// Add the input string to the history logs
				history.record ( parser.inputvalue (  ) );

				//
				// Else add the input to the matrix
				//
				matrix.add_sentence ( parser.inputvalue (  ) );

				//
				// Calculate NICOLE Output based on matrix and vocabulary
				//

				matrix.get_phrase ( &a, &b, &c, &d, &e );
				output = response.get ( a, b, c, d, e );
				matrix.reply_sentence ( output );

				if ( output == "" )
				{
					// We couldn't find an output, reset the matrix and let NICOLE
					// pick a new conversation thread
					cout << "NICOLE:> ** I'm speechless **" << endl;
					matrix.reset (  );

					// There is a 50% chance that NICOLE will respond
					if ( ( rand (  ) % 2 + 1 ) == 1 )
					{
						output = response.get ( "*", "*", "*", "*", "*" );
						matrix.reply_sentence ( output );
						if ( output != "" )
						{
							cout << "NICOLE: >" << output << endl;
							history.record ( output );
						}
					}
				}
				else
				{
					//
					// Output NICOLE responce
					//

					cout << "NICOLE: >" << output << endl;
					history.record ( output );

				}
				//
				// Rinse, repeat until quit selected
				//

			}													// if()

		}
	}															// while()

}

//
// Process the commands
//

void process_cmd ( Parser * p, Matrix * m )
{
#ifdef DEBUG
	cerr << "DEBUG: Command processing" << endl;
#endif

	if ( p->cmd_help (  ) )
	{
		p->show_help (  );
	}
	else if ( p->cmd_status (  ) )
	{
		p->show_status (  );
	}
	else if ( p->cmd_reset (  ) )
	{
		m->reset (  );
	}
	else if ( p->cmd_erase (  ) )
	{
		p->erase_nicole (  );
	}															//if()

}

/**
 * Display the heading/title banner to stdout
 */

void heading (  )
{

	cout << endl
		<< "N.I.C.O.L.E. - Nearly Intelligent Computer Operated Language Examiner"
		<< endl <<
		"=====================================================================" <<
		endl << endl << "** Type '/help' for a list of commands **" << endl <<
		endl;
}
